package com.qmrz.generator;

import com.qmrz.service.TableService;
import com.qmrz.utils.CGHelper;
import com.qmrz.utils.MapUtil;
import com.qmrz.utils.SpringContextUtil;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class InterfaceReadmeGenerator {
    private TableService tableService;
    private String dbName;

    public InterfaceReadmeGenerator(String dbName) {
        tableService = SpringContextUtil.getBean(TableService.class);
        this.dbName = dbName;
    }

    public void generator() {

        List<Map> tableList = tableService.getTableList(dbName);
        List<Map> columnList = tableService.getColumnList(dbName);

        Map result = columnList.stream().collect(Collectors.groupingBy(map -> map.get("table_name"), Collectors.toList()));

        CGHelper cgHelperTable = new CGHelper("inteface_tables_readme.md", dbName);
        cgHelperTable.generator("", "inteface_tables_readme.md", MapUtil.newMap()
                .put("dbname", dbName)
                .put("tableList", tableList)
                .getMap()
        );
         CGHelper cgHelper = new CGHelper("inteface_tables_readme.md", dbName);

        tableList.forEach(item -> {
            String table_name = item.get("table_name").toString();
            item.put("columnList", result.get(table_name));
            item.put("dbname", dbName);
            item.put("filename", "inteface_" + table_name + "_readme.md");
            cgHelper.generator("readme", "inteface_" + table_name + "_readme.md", item);
        });
    }
}
