package com.qmrz.generator;

import com.qmrz.service.TableService;
import com.qmrz.utils.CGHelper;
import com.qmrz.utils.Fn;
import com.qmrz.utils.SpringContextUtil;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * ServiceImpl生成
 */
public class Service2ImplGenerator {
    private TableService tableService;
    private String dbName;

    public Service2ImplGenerator(String dbName) {
        tableService = SpringContextUtil.getBean(TableService.class);
        this.dbName = dbName;
    }

    public void generator() {

        List<Map> tableList = tableService.getTableList(dbName);
        List<Map> columnList = tableService.getColumnList(dbName);

        Map result = columnList.stream().collect(Collectors.groupingBy(map -> map.get("table_name"), Collectors.toList()));

        CGHelper cgHelper = new CGHelper("service2Impl.ftl", dbName);

        tableList.forEach(item -> {
            String table_name = item.get("table_name").toString();
            String table_name2 = Fn.firstUpperCase(table_name);

            //去下划线且每个单词首字母大写
            table_name2 = Arrays.stream(table_name2.split("_")).map(Fn::firstUpperCase).collect(Collectors.joining());

            item.put("columnList", result.get(table_name));
            item.put("dbname", dbName);
            item.put("table_name2",table_name2);//首字母大写
            cgHelper.generator("service2Impl", table_name2 + "ServiceImpl.java", item);
        });
    }
}
