package com.qmrz.service.Impl;

import com.qmrz.service.TableService;
import com.qmrz.utils.DBHelper;
import com.qmrz.utils.MapUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * 表结构查询
 */
@Service
public class TableServiceImpl implements TableService {
    @Autowired
    DBHelper dbHelper;

    /**
     * 获取指定数据库的所有表结构
     * @param dbName
     * @return
     */
    @Override
    public List<Map> getColumnList(String dbName) {
        return dbHelper.selectList("TableMapper.getColumnList"
                , MapUtil.newMap()
                        .put("dbname", dbName)
                        .getMap()
        );
    }

    /**
     * 获取指定数据库的所有表
     * @param dbName
     * @return
     */
    @Override
    public List<Map> getTableList(String dbName) {
        return dbHelper.selectList("TableMapper.getTableList"
                , MapUtil.newMap()
                        .put("dbname", dbName)
                        .getMap()
        );
    }
}
