package com.qmrz.utils;

import freemarker.template.Configuration;
import freemarker.template.Template;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;

import java.io.*;
import java.util.HashMap;
import java.util.Map;

/**
 * 生成帮助类（CodeGenerator）
 */
@Slf4j
public class CGHelper {
    private final String templatePath = "src/main/resources/template";
    private String savePath;

    private String ftlName;

    public CGHelper(String ftlName, String saveDir) {
        this.ftlName = ftlName;
        this.savePath = "src/main/resources/code/" + saveDir;
    }

    /**
     * 写入文件
     *
     * @param saveFileName
     * @param viewModel
     */
    public void generator(String saveDir, String saveFileName, Map viewModel) {
        Configuration configuration = new Configuration();
        configuration.setClassicCompatible(true);
        Writer out = null;
        try {
            configuration.setDirectoryForTemplateLoading(new File(templatePath));
            Template template = configuration.getTemplate(ftlName);

            String save;
            if (StringUtils.isEmpty(saveDir)) {
                save = savePath;
            } else {
                save = savePath + "\\" + saveDir;
            }

            File fileDir = new File(save);
            if (!fileDir.exists() && !fileDir.isDirectory()) {
                fileDir.mkdirs();
            }

            File docFile = new File(save + "\\" + saveFileName);
            out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(docFile)));

            template.process(viewModel, out);
            log.info("成功生成：" + saveFileName);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (null != out) {
                    out.flush();
                }
            } catch (Exception e2) {
                e2.printStackTrace();
            }
        }
    }
}
