package com.qmrz.syncapi;

import com.alibaba.fastjson.JSONArray;
import com.qmrz.exception.ABException;
import com.qmrz.utils.*;
import lombok.extern.slf4j.Slf4j;

import java.time.LocalDateTime;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 同步 ${table_name}，${table_comment}
 */
@Slf4j
public class ${table_name2}Sync extends BaseSync {
    private String syncStartDate;
    private String syncEndDate;

    public ${table_name2}Sync(String syncStartDate, String syncEndDate) {
        this.syncStartDate = syncStartDate;

        //结束日期需要加一天，api同步时不包含结束日期
        this.syncEndDate = DateTimeUtil.datePlus(syncEndDate, 1);
    }

    @Override
    protected Map<String, String> getSyncFieldMapping() {
        //注意：不包含createtime，若是子表，则外键ID也不包含
        Map<String, String> fieldMapping = new HashMap<>();
        <#list columnList as item>
            <#if item.column_name != "createtime">
        fieldMapping.put("${item.column_name}", "${item.column_name_show_name}");
            </#if>
        </#list>

        return fieldMapping;
    }

    public JSONArray getOtherList() {
        throw new ABException("方法未实现");
        //return this.getSubList("子记录", (rowParent, rowSub) -> {
        //    rowSub.put("外键id", rowParent.get("id"));
        //});
    }

    @Override
    protected String insertMapID() {
        return "${table_name2}Mapper.sync_batch_insert";
    }

    @Override
    protected String updateMapID() {
        return "${table_name2}Mapper.sync_batch_update";
    }

    @Override
    protected String deleteMapID() {
        return "${table_name2}Mapper.sync_batch_delete";
    }

    @Override
    protected String getTableName() {
        return "${table_name}";
    }

    @Override
    protected String getPrimaryFieldName() {
        return "id";
    }

    @Override
    protected String getSyncUrl() {
        throw new ABException("方法未实现");
    }

    @Override
    protected boolean ispage() {
        return true;
    }

    @Override
    protected void insertAddField(Map insertMap) {
        insertMap.put("createtime", DateTimeUtil.format(LocalDateTime.now()));
    }

    /**
     * 查询DB数据，用与api数据比对是否增、删、改
     * @return
     */
    @Override
    protected List selectDB() {
        return SpringContextUtil.getBean(DBHelper.class).selectList("${table_name2}Mapper.sync_batch_select");
    }

    /**
     * 若需要api数据时（如主表），返回为false，否则true
     * @return
     */
    @Override
    protected boolean isOrigin() {
        return false;
    }

    /**
     * 若不需要api数据时，请先填充 this.originApi
     * @return
     */
    @Override
    protected JSONArray originApiData() {
        return null;
    }
}
