package com.qmrz.config;

import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * 数据库配置信息
 */
@Slf4j
@Component
@Data
@ConfigurationProperties(prefix = "db")
public class ConfigDBInfo {
    private String driver;
    private String url;
    private String username;
    private String password;

    public ConfigDBInfo() {
        log.info("------ ConfigDBInfo");
    }
}
