package com.qmrz.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

@Component
@Data
@ConfigurationProperties(prefix = "sys")
public class SysInfo {
    /** 站点名称 */
    private String name;

    /**
     * token密钥
     */
    private String policeSecret;

    /**
     * 过期毫秒数
     */
    private Long policeExpire;

    /**
     * wxapp表id为wxappid的做为系统公众号
     */
    private Integer wxappid;

    /**
     * 微信公众号域名
     */
    private String wxdomain;

    /**
     * 阿里短信应用id
     */
    private Integer alismsid;

    /**
     * 微信支付回调地址
     */
    private String paynotifyurl;

    /**
     * 订单生成的机器 IP
     */
    private String payip;


    /**
     * shiro session超时时间1天
     */
    private Integer globalSessionTimeout;

    /**
     * shiro 缓存前缀
     */
    private String shiroCachePrefix;

    /**
     * 是否开启api 数据同步
     */
    private Boolean openSyncApi;

    /**
     * 是否开启 自动分派
     */
    private Boolean openBatchAssign;

    /**
     * 数据库名
     */
    private String dbname;

    /**
     * 数据同步地址
     */
    private String syncapiurl;
}
