package com.qmrz.dto;

import com.qmrz.utils.Fn;
import java.util.HashMap;

/**
 * 通用参数接收模型(可扩展)
 */
public class PageMapDTO extends HashMap<String, Object> {
    /**
     * 页码 默认第1页
     * @return
     */
    public int getPageIndex() {
        int pageIdnex = Fn.toInt(this.get("pageIndex"));
        if (pageIdnex <= 0) {
            pageIdnex = 1;
        }
        return pageIdnex;
    }

    /**
     * 每页记录数 默认每页20条
     * @return
     */
    public int getPageSize(){
        int pageSize = Fn.toInt(this.get("pageSize"));
        if (pageSize <= 0) {
            pageSize = 20;
        }
        return pageSize;
    }
}
