package com.qmrz.dto;

import com.github.pagehelper.PageHelper;
import com.qmrz.admin.AdminLogin;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;

/**
 * 接收参数基础对象：含分页等属性
 */
@Data
@Slf4j
public class ParamPageDTO {
    /**
     * 默认第1页
     */
    private int pageIndex = 1;
    /**
     * 默认20条每页
     */
    private int pageSize = 20;

//    private Integer customerid;

    public ParamPageDTO() {
//        this.customerid = AdminLogin.getCustomerInfo().getCustomerID();
    }

    public ParamPageDTO(Integer customerid) {
//        this.customerid = customerid;
    }

    public ParamPageDTO(Integer customerid, Integer pageIndex, Integer pageSize) {
//        this.customerid = customerid;
        if (pageIndex <= 0) {
            pageIndex = 1;
        }
        this.pageIndex = pageIndex;
        if (pageSize <= 0) {
            pageSize = 20;
        }
        this.pageSize = pageSize;
    }

    public ParamPageDTO setCustomerid(Integer customerid) {
        log.warn("customerid不允许set，请使用_set");
        return this;
    }

    public ParamPageDTO _setCustomerid(Integer customerid) {
//        this.customerid = customerid;
        return this;
    }

    /**
     * 使用分页mapper时，请调用此方法
     */
    public void startPage() {
        PageHelper.startPage(pageIndex, pageSize);
    }
}
