package com.qmrz.exception;

import com.qmrz.utils.RDCode;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class ABException extends RuntimeException {
    private RDCode code;

    public ABException() {
        super(RDCode.exception.getMessage());
        this.code = RDCode.exception;
        log();
    }

    public ABException(String msg, Throwable cause) {
        super(msg, cause);
        this.code = RDCode.exception;
        log();
    }

    public ABException(RDCode code, String msg) {
        super(msg);
        this.code = code;
        log();
    }

    public ABException(RDCode code, String msg, Throwable cause) {
        super(msg, cause);
        this.code = code;
        log();
    }

    public ABException(String msg) {
        super(msg);
        this.code = RDCode.exception;
        log();
    }

    public ABException(RDCode code) {
        super(code.getMessage());
        this.code = code;
        log();
    }

    public RDCode getCode() {
        return code;
    }

    private void log() {
        log.error(this.getClass().getName() + ":" + this.code.getState() + ":" + this.getMessage());
    }
}
