package com.qmrz.exception;

import com.qmrz.utils.RD;
import com.qmrz.utils.Web;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.servlet.HandlerExceptionResolver;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 全局 spring 异常捕获
 */
@Slf4j
public class GlobalSpringException implements HandlerExceptionResolver {
    @Override
    public ModelAndView resolveException(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) {
        log.info("GlobalSpringException:" + ex.getMessage());
        if (ex instanceof org.apache.shiro.authz.UnauthorizedException) {
            Web.printRD(response, RD.notpermission());
            return new ModelAndView();
        } else if (ex instanceof ABException) {
            ABException ab = (ABException) ex;
            Web.printRD(response, RD.create(ab.getCode(), ab.getMessage(), null));
            return new ModelAndView();
        } else {
            Web.printRD(response, RD.exception(ex.getMessage()+ ex.getClass().getName()));
            log.error(RD.exception(ex.getMessage() + ex.getClass().getName()).toString());
            ex.printStackTrace();
            return new ModelAndView();
        }

//        return null;
    }
}
