package com.qmrz.mybatis.service;

import com.qmrz.mybatis.BasePO;
import com.qmrz.mybatis.Mapper;
import com.qmrz.mybatis.sql.BaseWrapper;
import com.qmrz.mybatis.sql.sqlnode.UpdateParam;

import java.util.List;
import java.util.function.Consumer;

public abstract class AbstractService<T extends BasePO> implements BaseService<T> {
    private Mapper<T> baseMapper;

    public AbstractService(Mapper<T> baseMapper){
        this.baseMapper = baseMapper;
    }

    public void setBaseMapper(Mapper<T> baseMapper) {
        this.baseMapper = baseMapper;
    }

    @Override
    public List<T> selectWrapper(Consumer<? super BaseWrapper> wrapper) {
        return baseMapper.selectWrapper(wrapper);
    }

    @Override
    public T selectOneWrapper(Consumer<? super BaseWrapper> wrapper) {
        return baseMapper.selectOneWrapper(wrapper);
    }

    @Override
    public Integer updateWrapper(Object param, Consumer<? super BaseWrapper> wrapper) {
        return baseMapper.updateWrapper(param, wrapper);
    }

    @Override
    public Integer deleteWrapper(Consumer<? super BaseWrapper> wrapper) {
        return baseMapper.deleteWrapper(wrapper);
    }

    @Override
    public List<T> select(Object whereObject) {
        return baseMapper.select(whereObject);
    }

    @Override
    public T selectOne(Object whereObject) {
        return baseMapper.selectOne(whereObject);
    }

    @Override
    public Integer selectCount(Object whereObject) {
        return baseMapper.selectCount(whereObject);
    }

    @Override
    public List<T> selectAll() {
        return baseMapper.selectAll();
    }

    @Override
    public T selectByPrimaryKey(Object paramPrimaryKey) {
        return baseMapper.selectByPrimaryKey(paramPrimaryKey);
    }

    @Override
    public int deleteByPrimaryKey(Object paramPrimaryKey) {
        return baseMapper.deleteByPrimaryKey(paramPrimaryKey);
    }

    @Override
    public int delete(Object whereObject) {
        return baseMapper.delete(whereObject);
    }

    @Override
    public int insert(T entity) {
        return baseMapper.insert(entity);
    }

    @Override
    public int updateByPrimaryKey(Object paramMap) {
        return baseMapper.updateByPrimaryKey(paramMap);
    }

    @Override
    public int update(UpdateParam updateParam) {
        return baseMapper.update(updateParam);
    }
}
