package com.qmrz.mybatis.sql;

import com.qmrz.mybatis.sql.statement.AndBlock;
import com.qmrz.mybatis.sql.statement.ConditionGeneral;

import java.util.*;

public class WrapperResolve {
    private BaseWrapper wrapper;
    private StringBuffer sql = new StringBuffer();
//    private List<String> fieldList = new ArrayList<>();
    private Map<String,Object> paramList = new LinkedHashMap<>();

    public WrapperResolve(BaseWrapper wrapper) {
        this.wrapper = wrapper;
    }

    public void getSQL() {
        getSQL(wrapper.getConditions());
    }

    private void getSQL(List<AbsWrapperData> list) {
        if (list.size() == 0) {
            return;
        }

        sql.append("(");
        list.forEach(item -> {
            getSQL(item);
        });
        sql.append(")");
    }

    private void getSQL(AbsWrapperData item) {
        if (item instanceof ConditionGeneral) {
            ConditionGeneral c = (ConditionGeneral) item;
            sql.append(item.getSQL());
            paramList.put(c.getFieldValue().getName(), c.getFieldValue().getValue());

        } else if (item instanceof BaseWrapper) {
            getSQL(((AndBlock) item).getConditions());
        }
    }
}
