package com.qmrz.mybatis.sql.statement;

import com.qmrz.exception.ABException;
import com.qmrz.mybatis.sql.AbsWrapperData;
import com.qmrz.mybatis.sql.ConditionGeneralValue;
import lombok.Data;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * sql: linkStr a between #{a1} and #{a2}
 */
@Data
public class ConditionBetween extends AbsWrapperData {
    /**
     * 条件左则字段名
     */
    private String fiedName;

    private List<ConditionGeneralValue> fieldValue;

    public ConditionBetween(int wrapperWhereStatus, int conditionWhereStatus, Class<?> classPO) {
        super(0, wrapperWhereStatus,conditionWhereStatus,classPO);
    }

    @Override
    public StringBuilder getSQL() {
        if (fieldValue.size() != 2) {
            throw new ABException("参数个数应该为2，目前是:" + fieldValue.size());
        }

        return new StringBuilder()
                .append(this.getLinkStr())
                .append(fiedName).append(" between ")
                .append("#{").append(fieldValue.get(0).getName()).append("}")
                .append(" and ")
                .append("#{").append(fieldValue.get(1).getName()).append("}");
    }

    @Override
    public Map<String, Object> getParam() {
        Map<String, Object> param = new LinkedHashMap<>();
        fieldValue.forEach(item->{
            param.put(item.getName(), item.getValue());
        });
        return param;
    }

    @Override
    protected void renameByParamName() {
        this.renameByParamName(fieldValue);
    }
}
