package com.qmrz.mybatis.sql.statement;

import com.qmrz.mybatis.sql.AbsWrapperData;
import com.qmrz.mybatis.sql.ConditionGeneralValue;
import lombok.Data;
import org.apache.commons.lang.StringUtils;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * sql: linkStr a in(#{a})
 */
@Data
public class ConditionIn extends AbsWrapperData {
    /**
     * 条件左则字段名
     */
    private String fiedName;

    private List<ConditionGeneralValue> fieldValue;

    public ConditionIn(int wrapperWhereStatus, int conditionWhereStatus, Class<?> classPO) {
        super(0, wrapperWhereStatus,conditionWhereStatus,classPO);
    }

    @Override
    public StringBuilder getSQL() {

        List<String> list = new ArrayList<>();
        fieldValue.forEach(item->list.add("#{"+item.getName()+"}"));

        StringBuilder sb= new StringBuilder()
                .append(this.getLinkStr())
                .append(fiedName).append(" in (")
                .append(StringUtils.join(list.toArray(),","))
                .append(")");
        return sb;
    }

    @Override
    public Map<String, Object> getParam() {
        Map<String, Object> param = new LinkedHashMap<>();
        fieldValue.forEach(item->{
            param.put(item.getName(), item.getValue());
        });
        return param;
    }

    @Override
    protected void renameByParamName() {
        this.renameByParamName(fieldValue);
    }
}
