package com.qmrz.mybatis.sql.statement;

import com.qmrz.mybatis.sql.AbsWrapperData;
import com.qmrz.mybatis.sql.ConditionGeneralValue;
import lombok.Data;

import java.util.LinkedHashMap;
import java.util.Map;

/**
 * sql: name like concat('%',#{name},'%')
 */
@Data
public class ConditionLike extends AbsWrapperData {
    /**
     * 条件左则字段名
     */
    private String fiedName;
    /**
     * 条件右侧参数名，及参数值
     */
    private ConditionGeneralValue fieldValue;

    public ConditionLike(int wrapperWhereStatus, int conditionWhereStatus, Class<?> classPO) {
        super(0, wrapperWhereStatus, conditionWhereStatus, classPO);
    }

    /**
     * 格式 " and/or fieldname=#{paramname}"
     *
     * @return
     */
    @Override
    public StringBuilder getSQL() {
        return new StringBuilder()
                .append(this.getLinkStr())
                .append(fiedName).append(" like")
                .append(" concat('%',#{").append(fieldValue.getName()).append("},'%')");
    }

    @Override
    public Map<String, Object> getParam() {
        Map<String, Object> param = new LinkedHashMap<>();
        if (fieldValue == null) {
            return param;
        }
        param.put(fieldValue.getName(), fieldValue.getValue());
        return param;
    }

    @Override
    protected void renameByParamName() {
        this.renameByParamName(fieldValue);
    }
}
