package com.qmrz.utils;

import java.security.SecureRandom;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Random;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicLong;

public class Identities {
    private static SecureRandom random = new SecureRandom();
    private static AtomicLong atomicLongID = new AtomicLong(10000L);

    public static String uuid() {
        return UUID.randomUUID().toString();
    }

    public static String uuid2() {
        return UUID.randomUUID().toString().replaceAll("-", "");
    }

    public static long randomLong() {
        return Math.abs(random.nextLong());
    }

    public static String randomBase62(int length) {
        byte[] randomBytes = new byte[length];
        random.nextBytes(randomBytes);
        return ConvertUtil.convertEncodeBase62(randomBytes);
    }

    /**
     * 连接对象
     * @param objs
     * @return
     */
    public static String concat(Object...objs) {

        if(objs==null || objs.length<1)return "";
        StringBuffer sb = new StringBuffer();
        for(Object obj : objs){
            sb.append(obj==null?"":obj.toString());
        }
        return sb.toString();
    }

    // 将date类型转换为字符串yyyy年MM月dd日
    public static String changeDateTOStr5(Date date,String pattern) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy年MM月dd日");
        return getDateToStr(date, sdf);
    }
    private static String getDateToStr(Date date, SimpleDateFormat sdf) {
        String dateStr = null;
        try {
            dateStr = sdf.format(date);
            return dateStr;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static String getTimeMillisSequence() {
        long nanoTime = System.nanoTime();
        String preFix = null;
        if (nanoTime < 0L) {
            preFix = "A";
            nanoTime = nanoTime + 9223372036854775807L + 1L;
        } else {
            preFix = "Z";
        }
        String nanoTimeStr = String.valueOf(nanoTime);
        int difBit = String.valueOf(9223372036854775807L).length() - nanoTimeStr.length();
        for (int i = 0; i < difBit; i++) {
            preFix = concat(new Object[]{preFix, "0"});
        }
        long last = atomicLongID.getAndIncrement() % 10000L + 10000L;
        return concat(new Object[]{changeDateTOStr5(new Date(), "yyyyMMddHHmmssSSS"), preFix, nanoTimeStr, Long.valueOf(last)});
    }
}
