package com.qmrz.utils;

import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
 * 集合分页
 */
@Slf4j
public class ListPageUtil {
    private List data;
    private int pageSize;

    private int pageCount;
    private int rowCount;

    public int getPageCount() {
        return pageCount;
    }

    public ListPageUtil(List data, int pageSize){
        this.data = data;
        this.rowCount = data.size();
        this.pageSize = pageSize;
        this.pageCount = this.rowCount / pageSize;
        if (this.rowCount % pageSize != 0) {
            this.pageCount++;
        }
    }

    public List start(int pageIndex) {
        int fromIndex = this.pageSize * (pageIndex - 1);
        int toIndex = fromIndex + this.pageSize;
        if (toIndex > this.rowCount) {
            toIndex = this.rowCount;
        }
        if (pageIndex > this.pageCount) {
            fromIndex = 0;
            toIndex = 0;
        }
        log.info("pageIndex="+pageIndex+", fromIndex="+fromIndex+", toIndex="+toIndex+",");
        return this.data.subList(fromIndex, toIndex);
    }
}
