package com.qmrz.utils;

import java.util.Map;

/**
 * Map 链式快速使用
 * @param <K>
 * @param <V>
 */
public class MapChain<K, V> {
    private Map<K, V> map;

    public MapChain(Map<K, V> map) {
        this.map = map;
    }

    /**
     * 可链式使用put
     * 如 put(k,v).put(k,v).put(k,v).put(k,v).put(k,v).getMap()
     * @param k
     * @param v
     * @return
     */
    @SuppressWarnings("unchecked")
    public MapChain<K, V> put(Object k, Object v) {
        map.put((K)k, (V)v);
        return this;
    }

    /**
     * 快速获取当前map
     * @return
     */
    public Map<K, V> getMap() {
        return map;
    }
}
