package com.qmrz.utils;

import java.util.LinkedHashMap;
import java.util.Map;

public class MapUtil {
    /**
     * 快速创建Map
     * 转http提交的参数形式
     *
     * @param map
     * @return
     */
    public static StringBuffer toParam(Map<String, String> map) {
        StringBuffer strParam = new StringBuffer();
        if (map == null) {
            return strParam;
        }
        int i = 0;
        for (String key : map.keySet()) {
            i++;
            if (i == 1) {
                strParam.append(key + "=" + map.get(key));
            } else {
                strParam.append("&" + key + "=" + map.get(key));
            }
        }
        return strParam;
    }

    /**
     * 快速创建map
     * @return
     */
    public static MapChain newMap() {
        return new MapChain<>(new LinkedHashMap<String, Object>());
    }

    /**
     * 快速创建map，并初始化
     * @param map
     * @return
     */
    public static MapChain newMap(Map<String, Object> map) {
        if (map == null) {
            return new MapChain<>(new LinkedHashMap<String, Object>());
        }
        return new MapChain<>(map);
    }
}
