package com.qmrz.utils;

import java.math.BigDecimal;

public class MoneyUtil {
    /**
     * 解析金额
     * 1、金额保留两位小数点后
     * 2、单元转分
     * @param payMoney
     * @return 返回分的无符号长整数类型
     */
    public static Long parsePayMoney(BigDecimal payMoney){
        float tmpMoney = payMoney.floatValue();
        //保留两位小数后去除小数点
        String strMoney = String.format("%.2f", tmpMoney).replace(".", "");
        return Long.parseUnsignedLong(strMoney);
    }

    /**
     * 分转元
     * @param payMoney
     * @return
     */
    public static BigDecimal parseFenToYuan(Long payMoney){
        return new BigDecimal(payMoney).divide(new BigDecimal(100));
    }

    /**
     * 转成标准金额，保留两位小数
     * @param payMoney
     * @return
     */
    public static BigDecimal parseStandardPay(BigDecimal payMoney){
        String strMoney = String.format("%.2f", payMoney.floatValue());
        return new BigDecimal(strMoney);
    }
}
