package com.qmrz.utils;

import com.github.pagehelper.Page;

import java.util.List;

public class PageData<T> {
    private Page data;
    private int pageIndex;
    private int pageSize;
    private int pageCount;
    private long rowCount;

    public PageData(List page) {
        this.data = (Page) page;
        this.pageIndex = data.getPageNum();
        this.pageSize = data.getPageSize();
        this.pageCount = data.getPages();
        this.rowCount = data.getTotal();
    }

    public static <T1> PageData<T1> newobj(Page page) {
        return new PageData<T1>(page);
    }

    public static <T1> PageData<T1> newobj(List page) {
        return new PageData<T1>(page);
    }

    public int getPageIndex() {
        return this.pageIndex;
    }

    public int getPageSize() {
        return this.pageSize;
    }

    public int getPageCount() {
        return this.pageCount;
    }

    public long getRowCount() {
        return this.rowCount;
    }

    public Page<T> getData() {
        return data;
    }
}
