package com.qmrz.utils;

/**
 * 统一数据响应状态值
 * 10200 成功
 * 10555 失败
 * 10556 失败，并返回具体错误信息（主要用于后台表单验证时一次性输出失败原因）
 * 10404 找不到地址
 * 10500 服务端异常
 * 10401 管理员未登录或超时
 * 10402 用户未登录或超时
 */
public enum RDCode {
    success(10200, "success"),
    failure(10555, "failure"),
    failureByForm(10556, "failureByForm"),
    notfound(10404, "请求地址不存在"),
    exception(10500, "服务端异常"),
    nopermission(10403, "无访问权限"),
    notlogin(10401, "未登录或超时"),
    usernotlogin(10402, "用户未登录或超时"),
    subuserlimit(10405, "子帐号不超过3个"),
    userexist(10406,"用户已存在"),
    nobindphone(10407,"未绑定手机号码"),
    notauthorization(10408, "用户未授权或超时"),
    exception_dida(20500, "迪达接口异常"),
    notqrcode(20409, "没有扫二维码"),
    exception_equip(30500, "设备接口异常");

    private int state = 0;
    private String message = "";

    private RDCode(int value, String message) {
        this.state = value;
        this.message = message;
    }

    public int getState() {
        return state;
    }

    public String getMessage() {
        return message;
    }
}
