package com.qmrz.utils;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

/**
 * 支持InputStream可重复读
 */
public class ReStreamInput {
    ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();

    public ReStreamInput(InputStream inputStream) throws IOException {
        byte[] buffer = new byte[1024];
        int len;
        while ((len = inputStream.read(buffer)) > -1) {
            byteArrayOutputStream.write(buffer, 0, len);
        }
        byteArrayOutputStream.flush();
    }

    public InputStream getInputStream(){
        return new ByteArrayInputStream(byteArrayOutputStream.toByteArray());
    }
}
