package com.qmrz.utils.enumutil;

import com.qmrz.utils.MapUtil;
import org.apache.commons.collections.keyvalue.DefaultMapEntry;

import java.util.*;

/**
 * 枚举工具
 */
public class EnumUtil {

    /**
     * 根据key获取枚举项
     * @param enumList
     * @param key
     * @return
     */
    public static IEmun getEnumByKey(IEmun[] enumList, int key) {
        for (IEmun item : enumList) {
            if (item.getKey() == key) {
                return item;
            }
        }
        return null;
    }

    /**
     * 将枚举按taxis从大到小排序
     *
     * @param enumList 枚举 项数组 如：PoliceRoleType.values()
     * @return
     */
    public static List<Map<String,Object>> sortByTaxis(IEmun[] enumList) {
        Map<Integer, IEmun> map = new TreeMap<>(new MapKeyComparator());

        for (IEmun s : enumList) {
            map.put(s.getTaxis(), s);
        }

        List<Map<String,Object>> mapList = new ArrayList<>();
        for (Map.Entry<Integer, IEmun> entry : map.entrySet()) {
            Map tmp = MapUtil.newMap().put("key", entry.getValue().getKey())
                    .put("name", entry.getValue().getName()).getMap();
            mapList.add(tmp);
        }

        return mapList;
    }

    /**
     * 比较器，从大到小
     */
    static class MapKeyComparator implements Comparator<Integer> {
        @Override
        public int compare(Integer o1, Integer o2) {
            return o2.compareTo(o1);
        }
    }
}
