package com.qmrz.utils.proxy;

import com.qmrz.utils.ReStreamInput;
import com.qmrz.utils.Web;
import com.qmrz.utils.http.MyTrustManager;
import lombok.extern.slf4j.Slf4j;
import net.coobird.thumbnailator.Thumbnails;

import javax.imageio.ImageIO;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;

/**
 * http代理
 */
@Slf4j
public class HttpProxy {
    /**
     * 响应http代理
     *
     * @param httpURL
     */
    public static void response(String httpURL) {
        try {
            Web.responseInputStream(getInputStream(httpURL));
        } catch (Exception e) {
            log.warn(e.getMessage() + "，url:" + httpURL);
            //e.printStackTrace();
        }
    }

    /**
     * 图片缩略图
     *
     * @param httpURL
     */
    public static void responseImageThumbnails(String httpURL) {
        try {
            ReStreamInput reStreamInput = new ReStreamInput(getInputStream(httpURL));
            InputStream is1 = reStreamInput.getInputStream();
            BufferedImage imageIO = ImageIO.read(is1);

            int w = imageIO.getWidth();
            int h = imageIO.getHeight();
            is1.close();
            is1 = null;
            imageIO = null;

            if (w > 250) {
                h = ((Double) (h / (w / 250d))).intValue();
                w = 250;
                OutputStream stream = Web.getResponse().getOutputStream();
                Thumbnails.of(reStreamInput.getInputStream()).size(w, h).toOutputStream(stream);
                stream.flush();
                stream.close();
            } else {
                Web.responseInputStream(reStreamInput.getInputStream());
            }
        } catch (Exception e) {
            log.warn(e.getMessage() + "，url:" + httpURL);
            //e.printStackTrace();
        }
    }

    public static InputStream getInputStream(String httpURL) {
        try {
            URL url = new URL(httpURL);
            URLConnection conn;
            if ("https".equals(url.toURI().getScheme())) {
                conn = url.openConnection();

                HttpsURLConnection conns = (HttpsURLConnection) conn;
                TrustManager[] tm = {new MyTrustManager()};
                SSLContext sslContext = SSLContext.getInstance("SSL", "SunJSSE");
                sslContext.init(null, tm, new java.security.SecureRandom());
                conns.setSSLSocketFactory(sslContext.getSocketFactory());
                conns.setHostnameVerifier((hostname, sslsession) -> true);
            } else {
                conn = url.openConnection();
            }

            HttpURLConnection conn2 = (HttpURLConnection) conn;
            conn2.setRequestMethod("GET");
            conn2.setConnectTimeout(5000);
            conn2.setReadTimeout(5000);
            return conn2.getInputStream();
        } catch (Exception e) {
            log.warn(e.getMessage() + "，url:" + httpURL);
            //e.printStackTrace();
            return null;
        }
    }
}
