package com.qmrz.utils.shiro;

import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.mgt.RealmSecurityManager;
import org.apache.shiro.realm.AuthorizingRealm;
import org.apache.shiro.subject.SimplePrincipalCollection;
import org.apache.shiro.subject.Subject;

@Slf4j
public class ShiroUtil {
    public void reflush(String principal){
        RealmSecurityManager rsm = (RealmSecurityManager) SecurityUtils.getSecurityManager();
//AccountAuthorizationRealm为在项目中定义的realm类
        AuthorizingRealm shiroRealm = (AuthorizingRealm)rsm.getRealms().iterator().next();
        Subject subject = SecurityUtils.getSubject();
        String realmName = subject.getPrincipals().getRealmNames().iterator().next();
        SimplePrincipalCollection principals = new SimplePrincipalCollection(principal,realmName);
        subject.runAs(principals);
//用realm删除principle
        shiroRealm.getAuthorizationCache().remove(subject.getPrincipal());
        shiroRealm.getAuthorizationCache().remove(subject.getPrincipals());
//切换身份也就是刷新了
        subject.releaseRunAs();
    }

    public static void clearAuth(){
        log.info("clearAuth");
        RealmSecurityManager rsm = (RealmSecurityManager)SecurityUtils.getSecurityManager();
        IShiroRealm realm = (IShiroRealm)rsm.getRealms().iterator().next();
        realm.clearAuth();
    }
}
